Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.wpi.first.wpilibj
Class AnalogTriggerOutput

    java.lang.Object
      edu.wpi.first.wpilibj.SensorBase
          edu.wpi.first.wpilibj.InterruptableSensorBase
              edu.wpi.first.wpilibj.DigitalSource
                  edu.wpi.first.wpilibj.AnalogTriggerOutput

All Implemented Interfaces:
  IDevice, IInputOutput

    public class AnalogTriggerOutput

extends DigitalSource
implements IInputOutput

Class to represent a specific output from an analog trigger. This class is used to get the current output value and also as a DigitalSource to provide routing of an output to digital subsystems on the FPGA such as Counter, Encoder, and Interrupt. The TriggerState output indicates the primary output value of the trigger. If the analog signal is less than the lower limit, the output is false. If the analog value is greater than the upper limit, then the output is true. If the analog value is in between, then the trigger output state maintains its most recent value. The InWindow output indicates whether or not the analog signal is inside the range defined by the limits. The RisingPulse and FallingPulse outputs detect an instantaneous transition from above the upper limit to below the lower limit, and vise versa. These pulses represent a rollover condition of a sensor and can be routed to an up / down couter or to interrupts. Because the outputs generate a pulse, they cannot be read directly. To help ensure that a rollover condition is not missed, there is an average rejection filter available that operates on the upper 8 bits of a 12 bit number and selects the nearest outlyer of 3 samples. This will reject a sample that is (due to averaging or sampling) errantly between the two limits. This filter will fail if more than one sample in a row is errantly in between the two limits. You may see this problem if attempting to use this feature with a mechanical rollover sensor, such as a 360 degree no-stop potentiometer without signal conditioning, because the rollover transition is not sharp / clean enough. Using the averaging engine may help with this, but rotational speeds of the sensor will then be limited.

Nested Class Summary
`class` | `AnalogTriggerOutput.AnalogTriggerOutputException` Exceptions dealing with improper operation of the Analog trigger output
`static class` | `AnalogTriggerOutput.Type` Type determines under what state the analog trigger evaluates to true or false

Field Summary

Fields inherited from class edu.wpi.first.wpilibj.InterruptableSensorBase
`interrupts, m_interrupt, m_interruptIndex, m_manager`

Fields inherited from class edu.wpi.first.wpilibj.SensorBase
`kAnalogChannels, kAnalogModules, kDigitalChannels, kPwmChannels, kRelayChannels, kSolenoidChannels, kSolenoidModules, kSystemClockTicksPerMicrosecond`

Constructor Summary
`AnalogTriggerOutput(AnalogTrigger trigger, AnalogTriggerOutput.Type outputType)` Create an object that represents one of the four outputs from an analog trigger.

Method Summary
`void` | `free()` Free the resources used by this object
`boolean` | `get()` Get the state of the analog trigger output.
`boolean` | `getAnalogTriggerForRouting()` Is this an analog trigger
`int` | `getChannelForRouting()` Get the channel routing number
`int` | `getModuleForRouting()` Get the module routing number

Methods inherited from class edu.wpi.first.wpilibj.InterruptableSensorBase
`allocateInterrupts, cancelInterrupts, disableInterrupts, enableInterrupts, readInterruptTimestamp, waitForInterrupt`

Methods inherited from class edu.wpi.first.wpilibj.SensorBase
`checkAnalogChannel, checkAnalogModule, checkDigitalChannel, checkDigitalModule, checkPWMChannel, checkPWMModule, checkRelayChannel, checkRelayModule, checkSolenoidChannel, checkSolenoidModule, getDefaultAnalogModule, getDefaultDigitalModule, getDefaultSolenoidModule, setDefaultAnalogModule, setDefaultDigitalModule, setDefaultSolenoidModule`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AnalogTriggerOutput

    public AnalogTriggerOutput(AnalogTrigger trigger,
                               AnalogTriggerOutput.Type outputType)

  Create an object that represents one of the four outputs from an analog trigger. Because this class derives from DigitalSource, it can be passed into routing functions for Counter, Encoder, etc.

  Parameters:
    `trigger` - The trigger for which this is an output.
    `outputType` - An enum that specifies the output on the trigger to represent.

Method Detail

### free

    public void free()

  Description copied from class: `SensorBase`
  Free the resources used by this object

  Overrides:
    `free` in class `SensorBase`

### get

    public boolean get()

  Get the state of the analog trigger output.

  Returns:
    The state of the analog trigger output.

### getChannelForRouting

    public int getChannelForRouting()

  Description copied from class: `DigitalSource`
  Get the channel routing number

  Specified by:
    `getChannelForRouting` in class `DigitalSource`
  Returns:
    channel routing number

### getModuleForRouting

    public int getModuleForRouting()

  Description copied from class: `DigitalSource`
  Get the module routing number

  Specified by:
    `getModuleForRouting` in class `DigitalSource`
  Returns:
    module routing number

### getAnalogTriggerForRouting

    public boolean getAnalogTriggerForRouting()

  Description copied from class: `DigitalSource`
  Is this an analog trigger

  Specified by:
    `getAnalogTriggerForRouting` in class `DigitalSource`
  Returns:
    true if this is an analog trigger

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| " 2013 FRC Java API "
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

"
For updated information see the Java FRC site
"